package io.ient.test;

import io.ient.test.context.FrameworkTestBase;
import io.ient.test.facets.Login;
import io.ient.test.framework.selenium.WaitTime;
import io.ient.test.framework.utils.DateUtils;
import io.ient.test.framework.utils.RandomDataUtils;
import io.ient.test.framework.utils.annotations.TestCaseID;
import io.ient.test.pages.HomePage;
import io.ient.test.pages.enterprise.*;
import org.testng.annotations.Test;
import org.testng.asserts.SoftAssert;

public class BulletinSubscriptionsTest extends FrameworkTestBase {

    @TestCaseID(ids = {"IENT-3065"})
    @Test
    public void verifyNewCategoryCreation() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        UserManagementPage userManagementPage = new UserManagementPage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        GlobalSettingsPage globalSettingsPage = new GlobalSettingsPage(driver);
        TenantsPage tenantsPage = new TenantsPage(driver);
        KeyCloakPage keyCloakPage = new KeyCloakPage(driver);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        boolean isSearchBarDisplayed = globalSettingsPage.isSearchBarDisplayed();
        softAssert.assertTrue(isSearchBarDisplayed, "Failed to display searchbar");
        boolean isSelectColumnsDisplayed = globalSettingsPage.isSelectColumnsDisplayed();
        softAssert.assertTrue(isSelectColumnsDisplayed, "Failed to display select columns");
        boolean isFilterIconDisplayed = globalSettingsPage.isFilterIconDisplayed();
        softAssert.assertTrue(isFilterIconDisplayed, "Failed to display filter");
        boolean isAddNewButtonDisplayed = globalSettingsPage.isAddNewButtonDisplayed();
        softAssert.assertTrue(isAddNewButtonDisplayed, "Failed to display AddNewButton");
        globalSettingsPage.clickOnTopLeftVerticalIcon();
        boolean isDownloadAsPdfDisplayed = globalSettingsPage.isDownloadAsPdfDisplayed();
        softAssert.assertTrue(isDownloadAsPdfDisplayed, "Failed to display DownloadAsPdf");
        boolean isDownloadAsCsvDisplayed = globalSettingsPage.isDownloadAsCsvDisplayed();
        softAssert.assertTrue(isDownloadAsCsvDisplayed, "Failed to display DownloadAsCSV");
        boolean isPageColumnDisplayed = globalSettingsPage.isPageColumnDisplayed("ID");
        softAssert.assertTrue(isPageColumnDisplayed, "Failed to display ID column");
        String name = "CM_" + RandomDataUtils.randomAlphabetic(4);
        String status = "Active";
        String inactiveStatus = "Inactive";
        bulletinSubscriptionsPage.createRecord(name, inactiveStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = bulletinSubscriptionsPage.isRecordDisplayed(name);
        softAssert.assertTrue(displayStatus, "Failed to create new category");
        homePage.clickOnEnterprise();
        userManagementPage.clickOnUserManagementTab();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String userName = "bulletinmanager." + RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String firstName = RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String lastName = RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String emailAddress = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase() + "@gmail.com";
        String salutation = "Mr";
        String role = "Bulletin Manager";
        String password = "Test@1234";
        userManagementPage.createUser(userName, firstName, lastName, emailAddress, role, salutation, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean userDisplayStatus = userManagementPage.isUserDisplayed(userName , firstName);
        softAssert.assertTrue(userDisplayStatus, "Failed to create new user");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginToKeycloak(testContext.app);
        String tenantName = testContext.app.getAgency().toLowerCase();
        keyCloakPage.clickOnTenantName(tenantName);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnViewAllUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.searchUserByName(userName);
        keyCloakPage.updateUserPassword(userName, password);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnAdminDropDownLink();
        keyCloakPage.clickOnSignOutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithUserCredentialsWithoutValidation(tenantName, userName, password, testContext.app);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAcceptTermsAndConditions();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        tenantsPage.clickOnSubmitButton();
        driver.sleep(WaitTime.LONG_WAIT);
        boolean loggedInStatus = homePage.isHomePage();
        softAssert.assertTrue(loggedInStatus, "Failed to login with new user");
        String message = RandomDataUtils.randomAlphabetic(6);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.clickOnAddButton();
        driver.sleep(WaitTime.LONG_WAIT);
        boolean isCategoryDisplayedInCaseForm_Inactive = bulletinSubscriptionsPage.isCategoryDisplayedInCaseForm(name);
        softAssert.assertFalse(isCategoryDisplayedInCaseForm_Inactive, "Failed to hide category in case form");
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.cancelCaseForm(message);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        boolean CategoryDisplayStatusInactive = bulletinSubscriptionsPage.isRecordDisplayedInBulletins(name);
        softAssert.assertFalse(CategoryDisplayStatusInactive, "Failed to hide category in bulletins");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editRecordStatus(name , status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.clearSearchTextField();
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean updatedCategoryDisplayStatus = bulletinSubscriptionsPage.isRecordDisplayed(name);
        softAssert.assertTrue(updatedCategoryDisplayStatus, "Failed to update category");
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithUserCredentialsWithoutValidation(tenantName, userName, password, testContext.app);
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.clickOnAddButton();
        driver.sleep(WaitTime.LONG_WAIT);
        boolean isCategoryDisplayedInCaseForm = bulletinSubscriptionsPage.isCategoryDisplayedInCaseForm(name);
        softAssert.assertTrue(isCategoryDisplayedInCaseForm, "Failed to display category in case form");
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.cancelCaseForm(message);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        boolean CategoryDisplayStatus = bulletinSubscriptionsPage.isRecordDisplayedInBulletins(name);
        softAssert.assertTrue(CategoryDisplayStatus, "Failed to display category in bulletins");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.clearSearchTextField();
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isCategoryDeleted = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isCategoryDeleted, "Failed to delete category");
        homePage.clickOnEnterprise();
        userManagementPage.clickOnUserManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        userManagementPage.clearSearchTextField();
        userManagementPage.searchUserByUserName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.clickOnSearchIcon();
        userManagementPage.deleteUser();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.searchUserByUserName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.clickOnSearchIcon();
        boolean isUserDeleted = userManagementPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isUserDeleted, "Failed to delete user");
        softAssert.assertAll();
    }


    @TestCaseID(ids = {"IENT-3066"})
    @Test
    public void verifyNewDivisionCreation() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        HomePage homePage = new HomePage(driver);
        UserManagementPage userManagementPage = new UserManagementPage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        GlobalSettingsPage globalSettingsPage = new GlobalSettingsPage(driver);
        TenantsPage tenantsPage = new TenantsPage(driver);
        KeyCloakPage keyCloakPage = new KeyCloakPage(driver);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        boolean isSearchBarDisplayed = globalSettingsPage.isSearchBarDisplayed();
        softAssert.assertTrue(isSearchBarDisplayed, "Failed to display searchbar");
        boolean isSelectColumnsDisplayed = globalSettingsPage.isSelectColumnsDisplayed();
        softAssert.assertTrue(isSelectColumnsDisplayed, "Failed to display select columns");
        boolean isFilterIconDisplayed = globalSettingsPage.isFilterIconDisplayed();
        softAssert.assertTrue(isFilterIconDisplayed, "Failed to display filter");
        boolean isAddNewButtonDisplayed = globalSettingsPage.isAddNewButtonDisplayed();
        softAssert.assertTrue(isAddNewButtonDisplayed, "Failed to display AddNewButton");
        globalSettingsPage.clickOnTopLeftVerticalIcon();
        boolean isDownloadAsPdfDisplayed = globalSettingsPage.isDownloadAsPdfDisplayed();
        softAssert.assertTrue(isDownloadAsPdfDisplayed, "Failed to display DownloadAsPdf");
        boolean isDownloadAsCsvDisplayed = globalSettingsPage.isDownloadAsCsvDisplayed();
        softAssert.assertTrue(isDownloadAsCsvDisplayed, "Failed to display DownloadAsCSV");
        boolean isPageColumnDisplayed = globalSettingsPage.isPageColumnDisplayed("ID");
        softAssert.assertTrue(isPageColumnDisplayed, "Failed to display ID column");
        String name = "DV_" + RandomDataUtils.randomAlphabetic(4);
        String status = "Active";
        String inactiveStatus = "Inactive";
        bulletinSubscriptionsPage.createRecord(name, inactiveStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = bulletinSubscriptionsPage.isRecordDisplayed(name);
        softAssert.assertTrue(displayStatus, "Failed to create new division");
        homePage.clickOnEnterprise();
        userManagementPage.clickOnUserManagementTab();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String userName = "bulletinmanager." + RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String firstName = RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String lastName = RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String emailAddress = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase() + "@gmail.com";
        String salutation = "Mr";
        String role = "Bulletin Manager";
        String password = "Test@1234";
        userManagementPage.createUser(userName, firstName, lastName, emailAddress, role, salutation, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean userDisplayStatus = userManagementPage.isUserDisplayed(userName , firstName);
        softAssert.assertTrue(userDisplayStatus, "Failed to create new user");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        login.loginToKeycloak(testContext.app);
        String tenantName = testContext.app.getAgency().toLowerCase();
        keyCloakPage.clickOnTenantName(tenantName);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnViewAllUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.searchUserByName(userName);
        keyCloakPage.updateUserPassword(userName, password);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnAdminDropDownLink();
        keyCloakPage.clickOnSignOutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithUserCredentialsWithoutValidation(tenantName, userName, password, testContext.app);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAcceptTermsAndConditions();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        tenantsPage.clickOnSubmitButton();
        driver.sleep(WaitTime.LONG_WAIT);
        boolean loggedInStatus = homePage.isHomePage();
        softAssert.assertTrue(loggedInStatus, "Failed to login with new user");
        String message = RandomDataUtils.randomAlphabetic(6);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.clickOnAddButton();
        driver.sleep(WaitTime.LONG_WAIT);
        boolean isDivisionDisplayedInCaseForm_Inactive = bulletinSubscriptionsPage.isDivisionDisplayedInCaseForm(name);
        softAssert.assertFalse(isDivisionDisplayedInCaseForm_Inactive, "Failed to hide division in case form");
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.cancelCaseForm(message);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        boolean divisionDisplayStatus_Inactive = bulletinSubscriptionsPage.isRecordDisplayedInBulletins(name);
        softAssert.assertFalse(divisionDisplayStatus_Inactive, "Failed to hide division in bulletins");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editRecordStatus(name , status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.clearSearchTextField();
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean updatedDivisionDisplayStatus = bulletinSubscriptionsPage.isRecordDisplayed(name);
        softAssert.assertTrue(updatedDivisionDisplayStatus, "Failed to update division");
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithUserCredentialsWithoutValidation(tenantName, userName, password, testContext.app);
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.clickOnAddButton();
        driver.sleep(WaitTime.LONG_WAIT);
        boolean isDivisionDisplayedInCaseForm = bulletinSubscriptionsPage.isDivisionDisplayedInCaseForm(name);
        softAssert.assertTrue(isDivisionDisplayedInCaseForm, "Failed to display division in case form");
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.cancelCaseForm(message);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        boolean divisionDisplayStatus = bulletinSubscriptionsPage.isRecordDisplayedInBulletins(name);
        softAssert.assertTrue(divisionDisplayStatus, "Failed to display division in bulletins");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.clearSearchTextField();
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDivisionDeleted = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDivisionDeleted, "Failed to delete division");
        homePage.clickOnEnterprise();
        userManagementPage.clickOnUserManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        userManagementPage.clearSearchTextField();
        userManagementPage.searchUserByUserName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.clickOnSearchIcon();
        userManagementPage.deleteUser();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.searchUserByUserName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.clickOnSearchIcon();
        boolean isUserDeleted = userManagementPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isUserDeleted, "Failed to delete user");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-3067"})
    @Test
    public void verifyNewRegionCreation() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        driver.sleep(WaitTime.SMALL_WAIT);
        HomePage homePage = new HomePage(driver);
        UserManagementPage userManagementPage = new UserManagementPage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        GlobalSettingsPage globalSettingsPage = new GlobalSettingsPage(driver);
        TenantsPage tenantsPage = new TenantsPage(driver);
        KeyCloakPage keyCloakPage = new KeyCloakPage(driver);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        boolean isSearchBarDisplayed = globalSettingsPage.isSearchBarDisplayed();
        softAssert.assertTrue(isSearchBarDisplayed, "Failed to display searchbar");
        boolean isSelectColumnsDisplayed = globalSettingsPage.isSelectColumnsDisplayed();
        softAssert.assertTrue(isSelectColumnsDisplayed, "Failed to display select columns");
        boolean isFilterIconDisplayed = globalSettingsPage.isFilterIconDisplayed();
        softAssert.assertTrue(isFilterIconDisplayed, "Failed to display filter");
        boolean isAddNewButtonDisplayed = globalSettingsPage.isAddNewButtonDisplayed();
        softAssert.assertTrue(isAddNewButtonDisplayed, "Failed to display AddNewButton");
        globalSettingsPage.clickOnTopLeftVerticalIcon();
        boolean isDownloadAsPdfDisplayed = globalSettingsPage.isDownloadAsPdfDisplayed();
        softAssert.assertTrue(isDownloadAsPdfDisplayed, "Failed to display DownloadAsPdf");
        boolean isDownloadAsCsvDisplayed = globalSettingsPage.isDownloadAsCsvDisplayed();
        softAssert.assertTrue(isDownloadAsCsvDisplayed, "Failed to display DownloadAsCSV");
        boolean isPageColumnDisplayed = globalSettingsPage.isPageColumnDisplayed("ID");
        softAssert.assertTrue(isPageColumnDisplayed, "Failed to display ID column");
        String name = "RM_" + RandomDataUtils.randomAlphabetic(4);
        String status = "Active";
        String inactiveStatus = "Inactive";
        bulletinSubscriptionsPage.createRecord(name, inactiveStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean displayStatus = bulletinSubscriptionsPage.isRecordDisplayed(name);
        softAssert.assertTrue(displayStatus, "Failed to create new region");
        homePage.clickOnEnterprise();
        userManagementPage.clickOnUserManagementTab();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String userName = "bulletinmanager." + RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String firstName = RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String lastName = RandomDataUtils.randomAlphabetic(5).toLowerCase();
        String emailAddress = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase() + "@gmail.com";
        String salutation = "Mr";
        String role = "Bulletin Manager";
        String password = "Test@1234";
        userManagementPage.createUser(userName, firstName, lastName, emailAddress, role, salutation, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean userDisplayStatus = userManagementPage.isUserDisplayed(userName , firstName);
        softAssert.assertTrue(userDisplayStatus, "Failed to create new user");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginToKeycloak(testContext.app);
        String tenantName = testContext.app.getAgency().toLowerCase();
        keyCloakPage.clickOnTenantName(tenantName);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnViewAllUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.searchUserByName(userName);
        keyCloakPage.updateUserPassword(userName, password);
        driver.sleep(WaitTime.XSMALL_WAIT);
        keyCloakPage.clickOnAdminDropDownLink();
        keyCloakPage.clickOnSignOutLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        login.loginWithUserCredentialsWithoutValidation(tenantName, userName, password, testContext.app);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAcceptTermsAndConditions();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        tenantsPage.clickOnSubmitButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean loggedInStatus = homePage.isHomePage();
        softAssert.assertTrue(loggedInStatus, "Failed to login with new user");
        String message = RandomDataUtils.randomAlphabetic(6);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.clickOnAddButton();
        driver.sleep(WaitTime.LONG_WAIT);
        boolean isDivisionDisplayedInCaseForm_Inactive = bulletinSubscriptionsPage.isRegionDisplayedInCaseForm(name);
        softAssert.assertFalse(isDivisionDisplayedInCaseForm_Inactive, "Failed to hide region in case form");
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.cancelCaseForm(message);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        boolean regionDisplayStatus_Inactive = bulletinSubscriptionsPage.isRecordDisplayedInBulletins(name);
        softAssert.assertFalse(regionDisplayStatus_Inactive, "Failed to hide region in bulletins");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editRecordStatus(name , status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.clearSearchTextField();
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean updatedRegionDisplayStatus = bulletinSubscriptionsPage.isRecordDisplayed(name);
        softAssert.assertTrue(updatedRegionDisplayStatus, "Failed to update region");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithUserCredentialsWithoutValidation(tenantName, userName, password, testContext.app);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.clickOnAddButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isRegionDisplayedInCaseForm = bulletinSubscriptionsPage.isRegionDisplayedInCaseForm(name);
        softAssert.assertTrue(isRegionDisplayedInCaseForm, "Failed to display region in case form");
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.cancelCaseForm(message);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        boolean regionDisplayStatus = bulletinSubscriptionsPage.isRecordDisplayedInBulletins(name);
        softAssert.assertTrue(regionDisplayStatus, "Failed to display region in bulletins");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.clearSearchTextField();
        bulletinSubscriptionsPage.searchRecordByName(name);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isRegionDeleted = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isRegionDeleted, "Failed to delete region");
        homePage.clickOnEnterprise();
        userManagementPage.clickOnUserManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        userManagementPage.clearSearchTextField();
        userManagementPage.searchUserByUserName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.clickOnSearchIcon();
        userManagementPage.deleteUser();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        userManagementPage.searchUserByUserName(userName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.clickOnSearchIcon();
        boolean isUserDeleted = userManagementPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isUserDeleted, "Failed to delete user");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-3144"})
    @Test
    public void verifyBulletinSubscriptionsNegative() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        String categoryName = "CM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String divisionName = "DV_" + RandomDataUtils.getRandomAlphanumeric(5);
        String regionName = "RM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String status = "Active";
        bulletinSubscriptionsPage.createRecord(categoryName, status);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        bulletinSubscriptionsPage.createRecord(divisionName, status);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        bulletinSubscriptionsPage.createRecord(regionName, status);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(categoryName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(divisionName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(regionName);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinManager(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String title1 = "Title1_" + RandomDataUtils.getRandomAlphanumeric(4);
        String title2 = "Title2_" + RandomDataUtils.getRandomAlphanumeric(4);
        String description = "Desc_" + RandomDataUtils.getRandomAlphanumeric(7);
        String expireDate = DateUtils.getFormattedDateAndTimeWithTimeZone(1, 0,"d","IST");
        String bulletinApproverName = testContext.app.getBulletinApproverUsername();
        String category = categoryName;
        String division = divisionName;
        String region = regionName;
        String nextState = "Submit for Approval";
        String publishTo = "All Subscribed";
        String approver = bulletinApproverName;
        String approveStatus = "Approved";
        bulletinSubscriptionsPage.createBulletinCase(title1, description, expireDate, category, division, region, nextState, publishTo, approver);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title1);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinApprover(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title1);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editBulletinCase(approveStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title1);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isBulletinCaseDisplayed = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertFalse(isBulletinCaseDisplayed, "Failed to display bulletin case");
        driver.sleep(WaitTime.XSMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinManager(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.createBulletinCase(title2, description, expireDate, category, division, region, nextState, publishTo, approver);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title2);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinApprover(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title2);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.editBulletinCase(approveStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title2);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isBulletinCaseNotDisplayed = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isBulletinCaseNotDisplayed, "Failed to hide bulletin case");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(categoryName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(categoryName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedCategory = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedCategory, "Failed to delete category");
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(divisionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(divisionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedDivision = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedDivision, "Failed to delete division");
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(regionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(regionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedRegion = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedRegion, "Failed to delete region");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-3082" , "IENT-3146" , "IENT-3070" , "IENT-3071" , "IENT-3072"})
    @Test
    public void verifyBulletinApproverReworkAndVisibilityForSupplierUserSupplierAdmin() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        GlobalSettingsPage globalSettingsPage = new GlobalSettingsPage(driver);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String categoryName = "CM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String divisionName = "DM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String regionName = "RM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String status = "Active";
        bulletinSubscriptionsPage.createRecord(categoryName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.createRecord(divisionName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.createRecord(regionName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(categoryName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(divisionName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(regionName);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinManager(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String title = "Title_" + RandomDataUtils.getRandomAlphanumeric(4);
        String description = "Desc_" + RandomDataUtils.getRandomAlphanumeric(7);
        String expireDate = DateUtils.getFormattedDateAndTimeWithTimeZone(1, 0,"d","IST");;
        String bulletinApproverName = testContext.app.getBulletinApproverUsername();
        String category = categoryName;
        String division = divisionName;
        String region = regionName;
        String submitForApprovalState = "Submit for Approval";
        String publishTo = "All Subscribed";
        String approver = bulletinApproverName;
        String approveStatus = "Approved";
        String reworkStatus = "Rework";
        bulletinSubscriptionsPage.createBulletinCase(title, description, expireDate, category, division, region, submitForApprovalState, publishTo, approver);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinApprover(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editReworkBulletinCase(reworkStatus, description);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinManager(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editBulletinCase(submitForApprovalState);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinApprover(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.editBulletinCase(approveStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isBulletinCasDisplayedForSU = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isBulletinCasDisplayedForSU, "Failed to display bulletin case for Supplier User");
        boolean isStatusColumnDisplayedForSU = globalSettingsPage.isPageColumnDisplayed("Status");
        softAssert.assertFalse(isStatusColumnDisplayedForSU, "Failed to hide Status column");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isBulletinCasDisplayedForSA = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isBulletinCasDisplayedForSA, "Failed to display bulletin case for Supplier Admin");
        boolean isStatusColumnDisplayedForSA = globalSettingsPage.isPageColumnDisplayed("Status");
        softAssert.assertFalse(isStatusColumnDisplayedForSA, "Failed to hide Status column");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isBulletinCaseDisplayed = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertFalse(isBulletinCaseDisplayed, "Failed to display bulletin case");
        boolean isStatusColumnDisplayed = globalSettingsPage.isPageColumnDisplayed("Status");
        softAssert.assertFalse(isStatusColumnDisplayed, "Failed to hide Status column");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(categoryName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(categoryName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedCategory = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedCategory, "Failed to delete category");
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(divisionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(divisionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedDivision = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedDivision, "Failed to delete division");
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(regionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(regionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedRegion = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedRegion, "Failed to delete region");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-3068" , "IENT-3069" , "IENT-3081" , "IENT-3087"})
    @Test
    public void verifyBulletinSubscriptionsBuyerSupplier() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        GlobalSettingsPage globalSettingsPage = new GlobalSettingsPage(driver);
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String categoryName = "CM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String divisionName = "DM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String regionName = "RM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String status = "Active";
        bulletinSubscriptionsPage.createRecord(categoryName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.createRecord(divisionName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.createRecord(regionName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(categoryName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(divisionName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(regionName);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(categoryName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(divisionName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(regionName);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(categoryName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(divisionName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(regionName);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(categoryName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(divisionName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(regionName);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinManager(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.LONG_WAIT);
        String title = "Title_" + RandomDataUtils.getRandomAlphanumeric(4);
        String description = "Desc_" + RandomDataUtils.getRandomAlphanumeric(7);
        String expireDate = DateUtils.getFormattedDateAndTimeWithTimeZone(1, 0,"d","IST");;
        String bulletinApproverName = testContext.app.getBulletinApproverUsername();
        String category = categoryName;
        String division = divisionName;
        String region = regionName;
        String submitForApprovalState = "Submit for Approval";
        String publishTo = "All Subscribed";
        String draftState = "Save as Draft";
        String approveStatus = "Approved";
        String approver = bulletinApproverName;
        bulletinSubscriptionsPage.createBulletinCase(title, description, expireDate, category, division, region, draftState, publishTo, approver);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        String fileName = "external.pdf";
        bulletinSubscriptionsPage.viewBulletinCase();
        driver.sleep(WaitTime.SMALL_WAIT);
        problemCasePage.clickOnAttachmentsTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        problemCasePage.addProblemCaseAttachmentsWithoutTag(fileName);
        driver.sleep(WaitTime.SMALL_WAIT);
        softAssert.assertTrue(problemCasePage.isAttachmentsWithoutTagDisplayed(fileName), "Failed to display attachment");
        softAssert.assertTrue(problemCasePage.isAttachmentsDownloadButtonDisplayed(), "Failed to display attachment download button");
        softAssert.assertTrue(problemCasePage.isAttachmentsVerticalIconDisplayed(fileName), "Failed to display attachment vertical icon");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinApprover(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isBulletinCaseDisplayed = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isBulletinCaseDisplayed, "Draft case is displaying to all");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinManager(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editBulletinCase(submitForApprovalState);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinApprover(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editBulletinCase(approveStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.viewBulletinCase();
        driver.sleep(WaitTime.SMALL_WAIT);
        problemCasePage.clickOnAttachmentsTab();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isAttachmentDisplayed = bulletinSubscriptionsPage.isAttachmentDisplayedInBulletinCase(fileName);
        softAssert.assertTrue(isAttachmentDisplayed, "Failed to display attachment");
        boolean isDownloadLinkDisplayed = bulletinSubscriptionsPage.isDownloadLinkDisplayed();
        softAssert.assertTrue(isDownloadLinkDisplayed, "Failed to display download option");
        boolean isEditDeleteOptionsDisplayed = bulletinSubscriptionsPage.isVerticalIconDisplayed();
        softAssert.assertFalse(isEditDeleteOptionsDisplayed, "Failed to hide edit delete options");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isBulletinCaseShouldDisplayed = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertFalse(isBulletinCaseShouldDisplayed, "Failed to display bulletin case");
        boolean isStatusColumnDisplayed = globalSettingsPage.isPageColumnDisplayed("Status");
        softAssert.assertFalse(isStatusColumnDisplayed, "Failed to hide status column");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(categoryName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(categoryName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedCategory = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedCategory, "Failed to delete category");
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(divisionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(divisionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedDivision = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedDivision, "Failed to delete division");
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(regionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(regionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedRegion = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedRegion, "Failed to delete region");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-3083"})
    @Test
    public void verifyBulletinApproverReject() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        BulletinSubscriptionsPage bulletinSubscriptionsPage = new BulletinSubscriptionsPage(driver);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        String categoryName = "CM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String divisionName = "DM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String regionName = "RM_" + RandomDataUtils.getRandomAlphanumeric(5);
        String status = "Active";
        bulletinSubscriptionsPage.createRecord(categoryName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.createRecord(divisionName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.createRecord(regionName, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(categoryName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(divisionName);
        bulletinSubscriptionsPage.selectBulletinSubscriptions(regionName);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinManager(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String title = "Title_" + RandomDataUtils.getRandomAlphanumeric(4);
        String description = "Desc_" + RandomDataUtils.getRandomAlphanumeric(7);
        String expireDate = DateUtils.getFormattedDateAndTimeWithTimeZone(1, 0,"d","IST");;
        String bulletinApproverName = testContext.app.getBulletinApproverUsername();
        String category = categoryName;
        String division = divisionName;
        String region = regionName;
        String submitForApprovalState = "Submit for Approval";
        String publishTo = "All Subscribed";
        String approver = bulletinApproverName;
        String rejectStatus = "Reject";
        bulletinSubscriptionsPage.createBulletinCase(title, description, expireDate, category, division, region, submitForApprovalState, publishTo, approver);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinApprover(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.editRejectBulletinCase(rejectStatus, description);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBulletinManager(testContext.app);
        homePage.clickOnBulletinsApp();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(title);
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isBulletinCaseDisplayed = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertFalse(isBulletinCaseDisplayed, "Failed to display bulletin case");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnBulletinSubscriptionsLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.unCheckBulletinSubscriptions();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnSaveButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        bulletinSubscriptionsPage.clickOnCategoryManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(categoryName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(categoryName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedCategory = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedCategory, "Failed to delete category");
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnDivisionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(divisionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(divisionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedDivision = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedDivision, "Failed to delete division");
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.clickOnRegionManagementTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(regionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        bulletinSubscriptionsPage.deleteRecord();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        bulletinSubscriptionsPage.searchRecordByName(regionName);
        bulletinSubscriptionsPage.clickOnSearchIcon();
        boolean isDeletedRegion = bulletinSubscriptionsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isDeletedRegion, "Failed to delete region");
        softAssert.assertAll();
    }
}